package dk.kapetanovic.devicepolicymanager;

import android.app.admin.DeviceAdminReceiver;
import android.content.Context;
import android.content.Intent;

import org.apache.cordova.CallbackContext;
import org.apache.cordova.PluginResult;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.HashMap;
import java.util.Map;

public class DeviceAdminReceiverImpl extends DeviceAdminReceiver {
    public static CallbackContext onChange;

    @Override
    public void onProfileProvisioningComplete (Context context, Intent intent) {
        broadcast("PROFILE_PROVISIONING_COMPLETE");
    }

    @Override
    public void onEnabled (Context context, Intent intent) {
        broadcast("DEVICE_ADMIN_ENABLED");
    }

    @Override
    public void onDisabled (Context context, Intent intent) {
        broadcast("DEVICE_ADMIN_DISABLED");
    }

    @Override
    public void onLockTaskModeEntering (Context context, Intent intent, String pkg) {
        HashMap<String, String> data = new HashMap<String, String>(1);
        data.put("lockTaskPackage", pkg);
        broadcast("LOCK_TASK_ENTERING", data);
    }

    @Override
    public void onLockTaskModeExiting (Context context, Intent intent) {
        broadcast("LOCK_TASK_EXITING");
    }

    private static void broadcast (String event) {
        broadcast(event, new HashMap<String, String>());
    }

    private static void broadcast (String event, Map<String, String> map) {
        if (onChange == null) return;

        PluginResult result = null;
        JSONObject json = new JSONObject();
        JSONObject data = new JSONObject(map);

        try {
            json.put("event", event);
            json.put("data", data);

            result = new PluginResult(PluginResult.Status.OK, json);
        } catch (JSONException e) {
            result = new PluginResult(PluginResult.Status.JSON_EXCEPTION, e.getMessage());
        }

        result.setKeepCallback(true);
        onChange.sendPluginResult(result);
    }
}
